diff -Naur moodle/backup/restorelib.php moodle-conditionals/backup/restorelib.php
--- moodle/backup/restorelib.php	2009-05-11 01:06:30.000000000 +0100
+++ moodle-conditionals/backup/restorelib.php	2009-09-16 13:38:34.000000000 +0100
@@ -232,20 +232,20 @@
         }
 
         // For each block, call its encode_content_links method
-        static $blockobjects = null; 
-        if (!isset($blockobjects)) { 
-            $blockobjects = array(); 
-            if ($blocks = get_records('block', 'visible', 1)) { 
-                foreach ($blocks as $block) { 
+        static $blockobjects = null;
+        if (!isset($blockobjects)) {
+            $blockobjects = array();
+            if ($blocks = get_records('block', 'visible', 1)) {
+                foreach ($blocks as $block) {
                     if ($blockobject = block_instance($block->name)) {
-                        $blockobjects[] = $blockobject; 
+                        $blockobjects[] = $blockobject;
                     }
                 }
             }
         }
-        
-        foreach ($blockobjects as $blockobject) { 
-            $content = $blockobject->decode_content_links($content,$restore); 
+
+        foreach ($blockobjects as $blockobject) {
+            $content = $blockobject->decode_content_links($content,$restore);
         }
 
         return $content;
@@ -847,6 +847,16 @@
                 $course->theme = '';
             }
 
+            /// START COMMENTS
+            $course->uselabel = isset($course_header->course_uselabel) ? addslashes($course_header->course_uselabel) : 0;
+            $course->personalizedlabel = isset($course_header->course_personalizedlabel) ? addslashes($course_header->course_personalizedlabel) : '';
+
+            /// END COMMENTS
+
+            /// START CONDITIONALS
+            $course->useconditionals = isset($course_header->course_useconditionals) ? addslashes($course_header->course_useconditionals) : 0;
+            /// END CONDITIONALS
+
             //Now insert the record
             $newid = insert_record("course",$course);
             if ($newid) {
@@ -1024,7 +1034,7 @@
 
                     // This will only be set if we come from 1.7 and above backups
                     //  Also, must do this before insert (insert_record unsets id)
-                    if (!empty($instance->id)) { 
+                    if (!empty($instance->id)) {
                         $oldid = $instance->id;
                     } else {
                         $oldid = 0;
@@ -1195,6 +1205,11 @@
                                             $course_module->groupingid = 0;
                                         }
                                         $course_module->groupmembersonly = $mod->groupmembersonly;
+
+                                        /// START COMMENTS
+                                        $course_module->info = backup_todb($mod->info);
+                                        /// END COMMENTS
+
                                         $course_module->instance = 0;
                                         //NOTE: The instance (new) is calculated and updated in db in the
                                         //      final step of the restore. We don't know it yet.
@@ -1215,6 +1230,23 @@
                                                           $keym,$newidmod,$mod->instance);
 
                                             $restore->mods[$mod->type]->instances[$mod->instance]->restored_as_course_module = $newidmod;
+
+                                            /// START CONDITIONALS
+                                            if ($mod->conditional) {
+                                                $conditional->moduleid = $newidmod;
+                                                $conditional->details = $mod->conditional->details;
+                                                $conditional->inuse = $mod->conditional->inuse;
+                                                $newidconditional = insert_record('conditional', $conditional);
+                                                if (isset($mod->conditional->conditions)) {
+                                                    foreach ($mod->conditional->conditions as $condition) {
+                                                        $tempcondition = $condition;
+                                                        $tempcondition->conditionalid = $newidconditional;
+                                                        insert_record('conditional_member', $tempcondition);
+                                                    }
+                                                }
+                                            }
+                                            /// END CONDITIONALS
+
                                         } else {
                                             $status = false;
                                         }
@@ -1922,7 +1954,7 @@
                                 $oldoutcome = backup_todb($info['GRADE_ITEM']['#']['OUTCOMEID']['0']['#']);
                                 if (empty($outcomes[$oldoutcome])) {
                                     continue; // error!
-                                } 
+                                }
                                 if (empty($outcomes[$oldoutcome]->id)) {
                                     $outcomes[$oldoutcome]->insert('restore');
                                     $outcomes[$oldoutcome]->use_in($restore->course_id);
@@ -2025,7 +2057,7 @@
 
 
         if ($status and !$importing and $restore_histories) {
-            /// following code is very inefficient 
+            /// following code is very inefficient
 
             $gchcount = count_records ('backup_ids', 'backup_code', $restore->backup_unique_code, 'table_name', 'grade_categories_history');
             $gghcount = count_records ('backup_ids', 'backup_code', $restore->backup_unique_code, 'table_name', 'grade_grades_history');
@@ -2058,7 +2090,7 @@
                                 //traverse_xmlize($info);                            //Debug
                                 //print_object ($GLOBALS['traverse_array']);         //Debug
                                 //$GLOBALS['traverse_array']="";                     //Debug
-    
+
                                 $oldobj = backup_getid($restore->backup_unique_code,"grade_categories", backup_todb($info['GRADE_CATEGORIES_HISTORY']['#']['OLDID']['0']['#']));
                                 if (empty($oldobj->new_id)) {
                                     // if the old object is not being restored, can't restoring its history
@@ -2069,12 +2101,12 @@
                                 $dbrec->action = backup_todb($info['GRADE_CATEGORIES_HISTORY']['#']['ACTION']['0']['#']);
                                 $dbrec->source = backup_todb($info['GRADE_CATEGORIES_HISTORY']['#']['SOURCE']['0']['#']);
                                 $dbrec->timemodified = backup_todb($info['GRADE_CATEGORIES_HISTORY']['#']['TIMEMODIFIED']['0']['#']);
-    
+
                                 // loggeduser might not be restored, e.g. admin
                                 if ($oldobj = backup_getid($restore->backup_unique_code,"user", backup_todb($info['GRADE_CATEGORIES_HISTORY']['#']['LOGGEDUSER']['0']['#']))) {
                                     $dbrec->loggeduser = $oldobj->new_id;
                                 }
-    
+
                                 // this item might not have a parent at all, do not skip it if no parent is specified
                                 if (backup_todb($info['GRADE_CATEGORIES_HISTORY']['#']['PARENT']['0']['#'])) {
                                     $oldobj = backup_getid($restore->backup_unique_code,"grade_categories", backup_todb($info['GRADE_CATEGORIES_HISTORY']['#']['PARENT']['0']['#']));
@@ -2106,15 +2138,15 @@
                                 $dbrec->aggregation = backup_todb($info['GRADE_CATEGORIES_HISTORY']['#']['AGGRETGATION']['0']['#']);
                                 $dbrec->keephigh = backup_todb($info['GRADE_CATEGORIES_HISTORY']['#']['KEEPHIGH']['0']['#']);
                                 $dbrec->droplow = backup_todb($info['GRADE_CATEGORIES_HISTORY']['#']['DROPLOW']['0']['#']);
-                                
+
                                 $dbrec->aggregateonlygraded = backup_todb($info['GRADE_CATEGORIES_HISTORY']['#']['AGGREGATEONLYGRADED']['0']['#']);
                                 $dbrec->aggregateoutcomes = backup_todb($info['GRADE_CATEGORIES_HISTORY']['#']['AGGREGATEOUTCOMES']['0']['#']);
                                 $dbrec->aggregatesubcats = backup_todb($info['GRADE_CATEGORIES_HISTORY']['#']['AGGREGATESUBCATS']['0']['#']);
-    
+
                                 $dbrec->courseid = $restore->course_id;
                                 insert_record('grade_categories_history', $dbrec);
                                 unset($dbrec);
-    
+
                             }
                             //Increment counters
                             $counter++;
@@ -2132,7 +2164,7 @@
                     }
                 }
             }
-    
+
             // process histories
             if ($gghcount && $status) {
                 if (!defined('RESTORE_SILENTLY')) {
@@ -2156,7 +2188,7 @@
                                 //traverse_xmlize($info);                            //Debug
                                 //print_object ($GLOBALS['traverse_array']);         //Debug
                                 //$GLOBALS['traverse_array']="";                     //Debug
-    
+
                                 $oldobj = backup_getid($restore->backup_unique_code,"grade_grades", backup_todb($info['GRADE_GRADES_HISTORY']['#']['OLDID']['0']['#']));
                                 if (empty($oldobj->new_id)) {
                                     // if the old object is not being restored, can't restoring its history
@@ -2170,7 +2202,7 @@
                                 if ($oldobj = backup_getid($restore->backup_unique_code,"user", backup_todb($info['GRADE_GRADES_HISTORY']['#']['LOGGEDUSER']['0']['#']))) {
                                     $dbrec->loggeduser = $oldobj->new_id;
                                 }
-                                
+
                                 $oldobj = backup_getid($restore->backup_unique_code,"grade_items", backup_todb($info['GRADE_GRADES_HISTORY']['#']['ITEMID']['0']['#']));
                                 $dbrec->itemid = $oldobj->new_id;
                                 if (empty($dbrec->itemid)) {
@@ -2185,12 +2217,12 @@
                                 if ($oldobj = backup_getid($restore->backup_unique_code,"user", backup_todb($info['GRADE_GRADES_HISTORY']['#']['USERMODIFIED']['0']['#']))) {
                                     $dbrec->usermodified = $oldobj->new_id;
                                 }
-                                
+
                                 if (backup_todb($info['GRADE_GRADES_HISTORY']['#']['RAWSCALEID']['0']['#'])) {
                                     $scale = backup_getid($restore->backup_unique_code,"scale",backup_todb($info['GRADE_GRADES_HISTORY']['#']['RAWSCALEID']['0']['#']));
                                     $dbrec->rawscaleid = $scale->new_id;
                                 }
-                                
+
                                 $dbrec->finalgrade = backup_todb($info['GRADE_GRADES_HISTORY']['#']['FINALGRADE']['0']['#']);
                                 $dbrec->hidden = backup_todb($info['GRADE_GRADES_HISTORY']['#']['HIDDEN']['0']['#']);
                                 $dbrec->locked = backup_todb($info['GRADE_GRADES_HISTORY']['#']['LOCKED']['0']['#']);
@@ -2202,10 +2234,10 @@
                                 $dbrec->feedbackformat = backup_todb($info['GRADE_TEXT_HISTORY']['#']['FEEDBACKFORMAT']['0']['#']);
                                 $dbrec->information = backup_todb($info['GRADE_TEXT_HISTORY']['#']['INFORMATION']['0']['#']);
                                 $dbrec->informationformat = backup_todb($info['GRADE_TEXT_HISTORY']['#']['INFORMATIONFORMAT']['0']['#']);
-    
+
                                 insert_record('grade_grades_history', $dbrec);
                                 unset($dbrec);
-    
+
                             }
                             //Increment counters
                             $counter++;
@@ -2223,9 +2255,9 @@
                     }
                 }
             }
-    
+
             // process histories
-    
+
             if ($gihcount && $status) {
                 if (!defined('RESTORE_SILENTLY')) {
                     echo '<li>'.get_string('gradeitemshistory','grades').'</li>';
@@ -2248,8 +2280,8 @@
                                 //traverse_xmlize($info);                            //Debug
                                 //print_object ($GLOBALS['traverse_array']);         //Debug
                                 //$GLOBALS['traverse_array']="";                     //Debug
-    
-    
+
+
                                 $oldobj = backup_getid($restore->backup_unique_code,"grade_items", backup_todb($info['GRADE_ITEM_HISTORY']['#']['OLDID']['0']['#']));
                                 if (empty($oldobj->new_id)) {
                                     // if the old object is not being restored, can't restoring its history
@@ -2270,31 +2302,31 @@
                                     $counter++;
                                     continue; // category not restored
                                 }
-    
+
                                 $dbrec->itemname= backup_todb($info['GRADE_ITEM_HISTORY']['#']['ITEMNAME']['0']['#']);
                                 $dbrec->itemtype = backup_todb($info['GRADE_ITEM_HISTORY']['#']['ITEMTYPE']['0']['#']);
                                 $dbrec->itemmodule = backup_todb($info['GRADE_ITEM_HISTORY']['#']['ITEMMODULE']['0']['#']);
-    
+
                                 // code from grade_items restore
                                 $iteminstance = backup_todb($info['GRADE_ITEM_HISTORY']['#']['ITEMINSTANCE']['0']['#']);
                                 // do not restore if this grade_item is a mod, and
                                 if ($dbrec->itemtype == 'mod') {
-    
+
                                     if (!restore_userdata_selected($restore,  $dbrec->itemmodule, $iteminstance)) {
                                         // module instance not selected when restored using granular
                                         // skip this item
                                         $counter++;
                                         continue;
                                     }
-    
+
                                     // iteminstance should point to new mod
-    
+
                                     $mod = backup_getid($restore->backup_unique_code,$dbrec->itemmodule, $iteminstance);
                                     $dbrec->iteminstance = $mod->new_id;
-    
+
                                 } else if ($dbrec->itemtype == 'category') {
                                     // the item instance should point to the new grade category
-    
+
                                     // only proceed if we are restoring all grade items
                                     if ($restoreall) {
                                         $category = backup_getid($restore->backup_unique_code,'grade_categories', $iteminstance);
@@ -2309,16 +2341,16 @@
                                         // TODO any special code needed here to restore course item without duplicating it?
                                         // find the course category with depth 1, and course id = current course id
                                         // this would have been already restored
-    
+
                                         $cat = get_record('grade_categories', 'depth', 1, 'courseid', $restore->course_id);
                                         $dbrec->iteminstance = $cat->id;
-    
+
                                     } else {
                                         $counter++;
                                         continue;
                                     }
                                 }
-    
+
                                 $dbrec->itemnumber = backup_todb($info['GRADE_ITEM_HISTORY']['#']['ITEMNUMBER']['0']['#']);
                                 $dbrec->iteminfo = backup_todb($info['GRADE_ITEM_HISTORY']['#']['ITEMINFO']['0']['#']);
                                 $dbrec->idnumber = backup_todb($info['GRADE_ITEM_HISTORY']['#']['IDNUMBER']['0']['#']);
@@ -2345,10 +2377,10 @@
                                 $dbrec->locked = backup_todb($info['GRADE_ITEM_HISTORY']['#']['LOCKED']['0']['#']);
                                 $dbrec->locktime = backup_todb($info['GRADE_ITEM_HISTORY']['#']['LOCKTIME']['0']['#']);
                                 $dbrec->needsupdate = backup_todb($info['GRADE_ITEM_HISTORY']['#']['NEEDSUPDATE']['0']['#']);
-    
+
                                 insert_record('grade_items_history', $dbrec);
                                 unset($dbrec);
-    
+
                             }
                             //Increment counters
                             $counter++;
@@ -2366,7 +2398,7 @@
                     }
                 }
             }
-    
+
             // process histories
             if ($gohcount && $status) {
                 if (!defined('RESTORE_SILENTLY')) {
@@ -2390,7 +2422,7 @@
                                 //traverse_xmlize($info);                            //Debug
                                 //print_object ($GLOBALS['traverse_array']);         //Debug
                                 //$GLOBALS['traverse_array']="";                     //Debug
-    
+
                                 $oldobj = backup_getid($restore->backup_unique_code,"grade_outcomes", backup_todb($info['GRADE_OUTCOME_HISTORY']['#']['OLDID']['0']['#']));
                                 if (empty($oldobj->new_id)) {
                                     // if the old object is not being restored, can't restoring its history
@@ -2410,10 +2442,10 @@
                                 $oldobj = backup_getid($restore->backup_unique_code,"scale", backup_todb($info['GRADE_OUTCOME_HISTORY']['#']['SCALEID']['0']['#']));
                                 $dbrec->scaleid = $oldobj->new_id;
                                 $dbrec->description = backup_todb($info['GRADE_OUTCOME_HISTORY']['#']['DESCRIPTION']['0']['#']);
-    
+
                                 insert_record('grade_outcomes_history', $dbrec);
                                 unset($dbrec);
-    
+
                             }
                             //Increment counters
                             $counter++;
@@ -3342,7 +3374,7 @@
     function restore_group_getid($restore, $groupid) {
         //We have to recode the groupid field
         $group = backup_getid($restore->backup_unique_code, 'groups', $groupid);
-        
+
         if ($restore->groups == RESTORE_GROUPS_NONE or $restore->groups == RESTORE_GROUPINGS_ONLY) {
             $group->new_id = 0;
         }
@@ -3356,7 +3388,7 @@
     function restore_grouping_getid($restore, $groupingid) {
         //We have to recode the groupid field
         $grouping = backup_getid($restore->backup_unique_code, 'groupings', $groupingid);
-        
+
         if ($restore->groups != RESTORE_GROUPS_GROUPINGS and $restore->groups != RESTORE_GROUPINGS_ONLY) {
             $grouping->new_id = 0;
         }
@@ -3489,7 +3521,7 @@
             //We have to recode the userid field
             if (!$user = backup_getid($restore->backup_unique_code,"user",$group_member->userid)) {
                 debugging("group membership can not be restored, user id $group_member->userid not present in backup");
-                // do not not block the restore 
+                // do not not block the restore
                 continue;
             }
 
@@ -3572,7 +3604,7 @@
         // now fix the defaultgroupingid in course
         $course = get_record('course', 'id', $restore->course_id);
         if ($course->defaultgroupingid) {
-            if ($grouping = restore_grouping_getid($restore, $course->defaultgroupingid)) { 
+            if ($grouping = restore_grouping_getid($restore, $course->defaultgroupingid)) {
                 set_field('course', 'defaultgroupingid', $grouping->new_id, 'id', $course->id);
             } else {
                 set_field('course', 'defaultgroupingid', 0, 'id', $course->id);
@@ -3824,7 +3856,7 @@
 
         $counter = 0;
 
-        // 'users' is the old users folder, 'user' is the new one, with a new hierarchy. Detect which one is here and treat accordingly 
+        // 'users' is the old users folder, 'user' is the new one, with a new hierarchy. Detect which one is here and treat accordingly
         //in CFG->dataroot
         $dest_dir = $CFG->dataroot."/user";
         $status = check_dir_exists($dest_dir,true);
@@ -3832,7 +3864,7 @@
         //Now, we iterate over "user_files" records to check if that user dir must be
         //copied (and renamed) to the "users" dir.
         $rootdir = $CFG->dataroot."/temp/backup/".$restore->backup_unique_code."/user_files";
-        
+
         //Check if directory exists
         $userlist = array();
 
@@ -3849,7 +3881,7 @@
                 }
             }
 
-            foreach ($userlist as $olduserid => $backup_location) { 
+            foreach ($userlist as $olduserid => $backup_location) {
                 //Look for dir like username in backup_ids
                 //If that user exists in backup_ids
                 if ($user = backup_getid($restore->backup_unique_code,"user",$olduserid)) {
@@ -4516,6 +4548,63 @@
                             $module->instance = $instance->new_id;
                             //print_object ($module);                             //Debug
                             $status = update_record("course_modules",$module);
+                            /// START CONDITIONALS
+                            $conditional = get_record('conditional','moduleid',$module->id);
+                            $conditions = get_records('conditional_member', 'conditionalid', $conditional->id);
+                            foreach ($conditions as $condition) {
+                                if ($condition->instance) {
+
+                                    $conditioninstance = backup_getid($restore->backup_unique_code,$condition->type,$condition->instance);
+                                    if ($conditioninstance) {
+                                        $condition->instance = $conditioninstance->new_id;
+                                        update_record('conditional_member',$condition);
+                                    }
+
+                                    if ($condition->type == 'choice' && $condition->subtype == 'particularanswer') {
+                                        $choiceanswer = backup_getid($restore->backup_unique_code,'choice_options',$condition->value);
+                                        $condition->value = $choiceanswer->new_id;
+                                        update_record('conditional_member',$condition);
+
+                                    } elseif ($condition->type == 'lesson' && $condition->subtype != 'grade') {
+                                        $lessonpage =  backup_getid($restore->backup_unique_code,'lesson_pages',$condition->subtype);
+                                        $condition->subtype = $lessonpage->new_id;
+                                        if ($page = get_record('lesson_pages', 'id', $condition->subtype) ) {
+                                            switch($page->qtype) {
+                                                case 1: /// short answer
+                                                case 2: /// true/false
+                                                case 3: /// multichoice
+                                                    $lessonanswer = backup_getid($restore->backup_unique_code,'lesson_answers',$condition->value);
+                                                    $condition->value = $lessonanswer->new_id;
+                                                    break;
+                                                default:
+                                                    break;
+                                            }
+                                        }
+                                        update_record('conditional_member',$condition);
+
+                                    } elseif ($condition->type == 'quiz' && $condition->subtype != 'grade') {
+
+                                        $quizquestioninstance =  backup_getid($restore->backup_unique_code,'quiz_question_instances',$condition->subtype);
+                                        $condition->subtype = $quizquestioninstance->new_id;
+                                        $questioninstance = get_record('quiz_question_instances', 'id', $condition->subtype);
+                                        if ($question = get_record('question', 'id', $questioninstance->question)) {
+                                            switch($question->qtype) {
+                                                case 'shortanswer':
+                                                case 'truefalse':
+                                                case 'multichoice':
+                                                case 'calculated':
+                                                    $questionanswers =  backup_getid($restore->backup_unique_code,'question_answers',$condition->value);
+                                                    $condition->value = $questionanswers->new_id;
+                                                    break;
+                                                default:
+                                                    break;
+                                            }
+                                        }
+                                        update_record('conditional_member',$condition);
+                                    }
+                                }
+                            }
+                            /// END CONDITIONALS
                         } else {
                             $status = false;
                         }
@@ -4530,7 +4619,7 @@
                                            FROM {$CFG->prefix}course_modules
                                            WHERE id = '$cm_module->new_id' AND
                                                  instance = '0'");
-                                                 
+
                     if($course_modules_inst_zero){ // Clean up the invalid instances
                          foreach($course_modules_inst_zero as $course_modules_inst){
                              delete_records('course_modules', 'id',$course_modules_inst->id);
@@ -5548,6 +5637,22 @@
                         case "ENROLPERIOD":
                             $this->info->course_enrolperiod = $this->getContents();
                             break;
+
+                        /// START COMMENTS
+                        case "USELABEL":
+                            $this->info->course_uselabel = $this->getContents();
+                            break;
+                        case "PERSONALIZEDLABEL":
+                            $this->info->course_personalizedlabel = $this->getContents();
+                            break;
+                        /// END COMMENTS
+
+                        /// START CONDITIONALS
+                        case "USECONDITIONALS":
+                            $this->info->course_useconditionals = $this->getContents();
+                            break;
+                        /// END CONDITIONALS
+
                     }
                 }
                 if ($this->tree[4] == "CATEGORY") {
@@ -5674,7 +5779,7 @@
                 if (!isset($this->temp)) {
                     $this->temp = "";
                 }
-                $this->temp .= htmlspecialchars(trim($this->content))."</".$tagName.">";    
+                $this->temp .= htmlspecialchars(trim($this->content))."</".$tagName.">";
 
                 //Dependig of different combinations, do different things
                 if ($this->level == 4) {
@@ -5689,7 +5794,7 @@
                             $xml_data = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n".$this->temp;
                             //Call to xmlize for this portion of xml data (one BLOCK)
                             //echo "-XMLIZE: ".strftime ("%X",time()),"-";                                                //Debug
-                            $data = xmlize($xml_data,0);         
+                            $data = xmlize($xml_data,0);
                             //echo strftime ("%X",time())."<p>";                                                          //Debug
                             //traverse_xmlize($data);                                                                     //Debug
                             //print_object ($GLOBALS['traverse_array']);                                                  //Debug
@@ -5699,7 +5804,7 @@
                                 //Get old id
                                 $oldid = $data['BLOCK']['#']['ID']['0']['#'];
                                 //Get instancedata
-                                
+
                                 if ($data = $data['BLOCK']['#']['INSTANCEDATA']['0']['#']) {
                                     //Restore code calls this multiple times - so might already have the newid
                                     if ($newid = backup_getid($this->preferences->backup_unique_code,'block_instance',$oldid)) {
@@ -5924,6 +6029,16 @@
                             $this->info->tempsection->mods[$this->info->tempmod->id]->idnumber =
                                 $this->info->tempmod->idnumber;
 
+                            /// START COMMENTS
+                            $this->info->tempsection->mods[$this->info->tempmod->id]->info =
+                                $this->info->tempmod->info;
+                            /// END COMMENTS
+
+                            /// START CONDITIONALS
+                            $this->info->tempsection->mods[$this->info->tempmod->id]->conditional =
+                                $this->info->tempmod->conditional;
+                            /// END CONDITIONALS
+
                             unset($this->info->tempmod);
                     }
                 }
